<template src="./createRelatedProductsComponent.htm"></template>

<script>

    import Vue from 'vue';
    import AutocompleteComponent from '../../../../../inputs/AutocompleteComponent.vue';
    import ValidationErrorsMixin from '../../../../../mixins/validationErrorsMixin.js';

    Vue.component('autocomplete-component', AutocompleteComponent);

    export default {

        data() {

            return {

                related_products: []
            }
        },

        mixins: [ ValidationErrorsMixin ],

        methods: {

            /**
             * Push selected value from autocomplete.
             *
             * @param value
             */
            pushToRelatedProducts(value) {

                if (! this.related_products.find( (el) => el.id === value.id)) {

                    this.related_products.push(value);
                }
            },


            /**
             * Remove related product from array.
             *
             * @param index
             */
            removeRelatedProduct(index) {

                this.related_products.splice(index, 1);
            },


            /**
             * @param src
             * @return {*}
             */
            imageCacheRoute(src) {

                return route('images.cache', { template: 'small', filename: src });
            }
        },

        watch: {

            /**
             * Push related products to store.
             */
            related_products(newRelatedProducts) {

                this.$store.dispatch('setProductRelatedProducts', newRelatedProducts);
            },
        }
    }

</script>